/* zmakebas - convert a text file containing a speccy Basic program
 *            into an actual program file loadable on a speccy.
 *
 * Public domain by Russell Marks, 1998.
 */

/* warning: this is probably the least structured program ever.
 * I guess that's what comes from hacking something into existence... :-/
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef HAVE_GETOPT
#include <unistd.h>
#endif
#include <math.h>
#include <ctype.h>

int main(int argc,char *argv[])
{
//#ifdef MSDOS
//static unsigned char buf[512],lcasebuf[512],outbuf[1024];
//#else
static unsigned char buf[2048],lcasebuf[2048],outbuf[4096];
//#endif
int f,toknum,toklen,linenum,linelen,lastline;

//Flags
int in_quotes=0;
int gr_block=0;
int in_rem=0;
int ivideo=0;
int cvideob=0;
int cvideof=0;
int is_deffn=0;

char **tarrptr;
unsigned char *ptr,*ptr2,*linestart,*outptr,*remptr,*fileptr;
double num;
int num_exp;
unsigned long num_mantissa;
int textlinenum;
int chk=0;
int alttok;
int passnum=1;
long merge_off;

FILE *in=stdin,*out=stdout;

strcpy(speccy_filename,"");
strcpy(infile,"-");
strcpy(outfile,DEFAULT_OUTPUT);
parse_options(argc,argv);

if(strcmp(infile,"-")!=0 && (in=fopen(infile,"r"))==NULL)
  fprintf(stderr,"[Aborted] Couldn't open \"%s\" input file.\n",infile),exit(1);


fileptr=filebuf;
linenum=-1;		/* to set lastline */

/* we make one pass if using line numbers, two if using labels */

do
  {
  if(use_labels) linenum=autostart-autoincr;
  textlinenum=0;
  if(passnum>1 && fseek(in,0L,SEEK_SET)!=0)
    {
    fprintf(stderr,"Need seekable input for label support\n");
    exit(1);
    }
  
  while(fgets(buf+1,sizeof(buf)-1,in)!=NULL)
    {
    buf[0]=32;		/* just in case, for all the ptr[-1] stuff */
    textlinenum++;
    lastline=linenum;
    
    if(buf[strlen(buf)-1]=='\n') buf[strlen(buf)-1]=0;
    
    /* allow for (shell-style) comments which don't appear in the program,
     * and also ignore blank lines.
     */
    if(buf[1]==0 || buf[1]=='#') continue;

    
    /* check for line continuation */
    while(buf[strlen(buf)-1]=='\\')
      {
      f=strlen(buf)-1;
      fgets(buf+f,sizeof(buf)-f,in);
      textlinenum++;
      if(buf[strlen(buf)-1]=='\n') buf[strlen(buf)-1]=0;
      }
    
    if(strlen(buf)>=sizeof(buf)-MAX_LABEL_LEN-1)
      {
      /* this is nasty, but given how the label substitution works it's
       * probably the safest thing to do.
       */
      fprintf(stderr,"line %d: line too big for input buffer\n",textlinenum);
      exit(1);
      }
    
    /* get line number (or assign one) */
    if(use_labels)
      {
      linestart=buf;
      /* assign a line number */
      linenum+=autoincr;
      if(linenum>9999)
        fprintf(stderr,"Generated line number is >9999 - %s\n",
          (autostart>1 || autoincr>1)?"try using `-s 1 -i 1'"
                                     :"too many lines!"),
          exit(1);
      }
    else
      {
      ptr=buf;
      while(isspace(*ptr)) ptr++;
      if(!isdigit(*ptr))
        {
        fprintf(stderr,"line %d: missing line number\n",textlinenum);
        exit(1);
        }
      linenum=(int)strtol(ptr,(char **)&linestart,10);
    
      if(linenum<=lastline)
        {
        fprintf(stderr,"line %d: line no. not greater than previous one\n",
        	textlinenum);
        exit(1);
        }
      }
    
    if(linenum<0 || linenum>9999)
      {
      fprintf(stderr,"line %d: line no. out of range\n",textlinenum);
      exit(1);
      }
    
    /* lose remaining spaces */
    while(isspace(*linestart)) linestart++;
    
    /* check there's no line numbers on label-using programs */
    if(use_labels && isdigit(*linestart))
      {
      fprintf(stderr,"line %d: line number used in labels mode\n",
      	textlinenum);
      exit(1);
      }
    
    if(use_labels && *linestart=='@')
      {
      if((ptr=strchr(linestart,':'))==NULL)
        {
        fprintf(stderr,"line %d: incomplete token definition\n",textlinenum);
        exit(1);
        }
      if(ptr-linestart-1>MAX_LABEL_LEN)
        {
        fprintf(stderr,"line %d: token too long\n",textlinenum);
        exit(1);
        }
      if(passnum==1)
        {
        *ptr=0;
        label_lines[labelend]=linenum;
        strcpy(labels[labelend++],linestart+1);
        if(labelend>=MAX_LABELS)
          {
          fprintf(stderr,"line %d: too many labels\n",textlinenum);
          exit(1);
          }
        for(f=0;f<labelend-1;f++)
          if(strcmp(linestart+1,labels[f])==0)
            {
            fprintf(stderr,"iine %d: attempt to redefine label\n",textlinenum);
            exit(1);
            }
        *ptr=':';
        }
      
      linestart=ptr+1;
      while(isspace(*linestart)) linestart++;
      
      /* if now blank, don't bother inserting an actual line here;
       * instead, fiddle linenum so the next line will have the
       * same number.
       */
      if(*linestart==0)
        {
        linenum-=autoincr;
        continue;
        }
      }
    
    if(use_labels && passnum==1) continue;
    
    /* make token comparison copy of line. this has lowercase letters and
     * blanked-out strings.
     */
    ptr=linestart; in_quotes=0;
    ptr2=lcasebuf;
    while(*ptr)
      {
      		
	  if(*ptr=='"') in_quotes=!in_quotes;
      if(in_quotes && *ptr!='"')
             {  *ptr2++=32;
             }else{
             *ptr2++=tolower(*ptr);
             ptr++;
             }
             
    *ptr2=0;ivideo=0;cvideob=0;cvideof=0;gr_block=0;
    
    /* now convert any token without letters either side to the correct
     * speccy token number. (Any space this leaves in the string is replaced
     * by 0x01 chars.)
     *
     * However, we need to check for REM first. If found, no token/num stuff
     * is performed on the line after that point.
     */
    remptr=NULL;
    
    if((ptr=strstr(lcasebuf,"rem"))!=NULL &&
       !isalpha(ptr[-1]) && !isalpha(ptr[3]))
      {
      ptr2=linestart+(ptr-lcasebuf);
      /* endpoint for checks must be here, then. */
      remptr=ptr2;
      *remptr=*ptr=0;
      /* the zero will be replaced with the REM token later */
      ptr2[1]=ptr[1]=ptr2[2]=ptr[2]=1;
      /* absorb at most one trailing space */
      if(ptr[3]==' ') ptr2[3]=ptr[3]=1;
      }
    
    toknum=256; alttok=1;
    for(tarrptr=tokens;*tarrptr!=NULL;tarrptr++)
      {
      if(alttok) toknum--;
      alttok=!alttok;
      if(**tarrptr==0) continue;
      toklen=strlen(*tarrptr);
      ptr=lcasebuf;
      
      while((ptr=strstr(ptr,*tarrptr))!=NULL)
        {
        /* check it's not in the middle of a word etc., except for
         * <>, <=, >=.
         */
        if((*tarrptr)[0]=='<' || (*tarrptr)[1]=='=' ||
           (!isalpha(ptr[-1]) && !isalpha(ptr[toklen])))
          {
          ptr2=linestart+(ptr-lcasebuf);
          /* the token text is overwritten in the lcase copy too, to
           * avoid problems with e.g. go to/to.
           */
          *ptr2=*ptr=toknum;
          for(f=1;f<toklen;f++) ptr2[f]=ptr[f]=1;
          
          /* absorb trailing spaces too */
          while(ptr2[f]==' ')
            ptr2[f++]=1;
          
          /* for BIN, we need the token right before the number. */
          if(toknum==BIN_TOKEN_NUM)
            {
            *ptr2=*ptr=1;
            ptr2[f-1]=ptr[f-1]=toknum;
            }
          }
          
        ptr+=toklen; 
               
        }
      }
    
    if(use_labels)
      {
      /* replace @label with matching number.
       * this expands labels in strings too, since:
       * 1. it seems reasonable to assume you might want this;
       * 2. it makes the code a bit simpler :-) ;
       * 3. you can use the escape `\@' to get a literal `@' anyway.
       */
      
      ptr=linestart;
      while((ptr=strchr(ptr,'@'))!=NULL)
        {
        if(ptr[-1]=='\\')
          {
          ptr++;
          continue;
          }
        
        /* the easiest way to spot them is to try matching against
         * each label in turn. It's gross, but at least it's sane
         * and doesn't restrict what you can have as a label.
         * We also test that the char after a match is not a printable
         * ascii char (other than space or colon), to prevent matches
         * against the shorter of two possibilities.
         */
        ptr++;
        for(f=0;f<labelend;f++)
          {
          int len=strlen(labels[f]);
          if(memcmp(labels[f],ptr,len)==0 &&
            (ptr[len]<33 || ptr[len]>126 || ptr[len]==':'))
            {
            unsigned char numbuf[20];
            
            /* this could be optimised to use a single memmove(), but
             * at least this way it's clear(er) what's happening.
             */
            /* switch text for label. first, remove text */
            memmove(ptr-1,ptr+len,strlen(ptr+len)+1);
            /* make number string */
            sprintf(numbuf,"%d",label_lines[f]);
            len=strlen(numbuf);
            /* insert room for number string */
            ptr--;
            memmove(ptr+len,ptr,strlen(ptr)+1);
            memcpy(ptr,numbuf,len);
            ptr+=len;
            break;
            }
          }
          
          
        if(f==labelend)
          {
          fprintf(stderr,"line %d: undefined label\n",textlinenum);
          exit(1);
          }
        }
      }
      
    
    if(remptr) *remptr=REM_TOKEN_NUM;
    
    /* remove 0x01s, deal with backslash things, and add numbers */
    ptr=linestart;
    outptr=outbuf;
    in_rem=0;
	in_quotes=0;
    
    while(*ptr)
      {
      	
      if(outptr>outbuf+sizeof(outbuf)-10) fprintf(stderr,"line %d: line too big\n",textlinenum);exit(1);
             
              
     // ADD BY XavSnap >>
                              				  
     /* "Def Fn" trigger*/
     if(*ptr==206) is_deffn=!is_deffn;
      
    /* "Def Fn" vars buffer, and add room in this function*/     
        if((*ptr==')' || *ptr==',') &&  is_deffn){
				   *outptr++=0x0E;
				   *outptr++=0;
		 		   *outptr++=0;
		 		   *outptr++=0;
		 		   *outptr++=0;
				   *outptr++=0;
				    if(*ptr==')') is_deffn=0;
		 		   }
		 
      // << ADD BY XavSnap
 
         if (in_quotes && *ptr=='"') //RESET Video tags.
		 {
                          if (cvideob)*outptr++=17;*outptr++=7;cvideob=0;
                          if (cvideof)*outptr++=16;*outptr++=0;cvideof=0;                    
                          if (ivideo)*outptr++=20;*outptr++=0;ivideo=!ivideo;
          }
          
         if (*ptr=='"') { 
		 in_quotes=!in_quotes; // stard or end.
		 fprintf(stderr,"prt flag: %d  %d\n",*ptr,in_quotes);
		 } 
      
      /* as well as 0x01 chars, we skip tabs. */
      if(*ptr==1 || *ptr==9 || (!in_quotes && !in_rem && *ptr==' ')) ptr++; continue;
    
      
      if(*ptr==REM_TOKEN_NUM) in_rem=1;
      
//      if(!in_rem && *ptr=='\\')   //REMMED BY XavSnap   
      if(*ptr=='\\')
        {
        // UDG GRAPHICS CHARACTERS
        if(isalpha(ptr[1]) && strchr("VWXYZvwxyz",ptr[1])==NULL)
          {
		  *outptr++=144+tolower(ptr[1])-'a';
		  }
        else{
		
        // GET '\' other specs.
          switch(ptr[1])
            {
            case '\\':	*outptr++='\\';	break;
            case '@':	*outptr++='@';	break;
            case '*':	*outptr++=127;	break;	/* copyright symbol */
            
// ADD BY XavSnap >>
            // DEC ou HEX value {128} or {h80}
            case '{':
			{
            static  unsigned char asciinumbuf[3];
            int mydecval;
            if (ptr[2]!=125)asciinumbuf[0]=ptr[2];
            if (ptr[3]!=125) asciinumbuf[1]=ptr[3];
            if (ptr[4]!=125) asciinumbuf[2]=ptr[4];
            if (ptr[5]!=125) asciinumbuf[3]=ptr[5];
            
            if (asciinumbuf[0]=='h' || asciinumbuf[0]=='H')
			{
            sscanf(&asciinumbuf[1], "%2x",&mydecval);         
            sscanf(&asciinumbuf[1], "%2x",outptr++);                                   
            }else{
            sscanf(&asciinumbuf[0], "%d",&mydecval);         
            sscanf(&asciinumbuf[0], "%d",outptr++);
            }
            
            if (mydecval>=255) fprintf(stderr,"line %d: {Ascii}=%s [%d] value too big !!! \n",textlinenum,&asciinumbuf[0],mydecval);
            
			if (ptr[2]==125)ptr++;break;
            if (ptr[3]==125)ptr+=2;break;
            if (ptr[4]==125)ptr+=3;break;
            if (ptr[5]==125)ptr+=4;break;
			} //End case
			 
// INverted video 
            case '|':{
                  if (ivideo){
                  *outptr++=20;
                  *outptr++=0;
                  ivideo=0;      
                  } else {
                  *outptr++=20;
                  *outptr++=1;
                  ivideo=1;          
                  }
				  break;
                  } //End case
                  
// Background colors. 
            case '0':{ // Black
                  *outptr++=17;
                  *outptr++=0;
                  cvideob=1;                 
				  break;
                  } //End case
            case '1':{ // Blue
                  *outptr++=17;
                  *outptr++=1;
                  cvideob=1;                 
				break;
                  } //End case
            case '2':{ // Red
                  *outptr++=17;
                  *outptr++=2;
                  cvideob=1;                 
				break;
                  } //End case
            case '3':{ // Maganta
                  *outptr++=17;
                  *outptr++=3;
                  cvideob=1;                 
				break;
                  } //End case                           
            case '4':{ // Green
                  *outptr++=17;
                  *outptr++=4;
                  cvideob=1;                 
				break;
                  } //End case
            case '5':{ // Cyan
                  *outptr++=17;
                  *outptr++=5;
                  cvideob=1;                 
				break;
                  } //End case     
            case '6':{ // Yellow
                  *outptr++=17;
                  *outptr++=6;
                  cvideob=1;                 
				break;
                  } //End case
            case '7':{ // White
                  *outptr++=17;
                  *outptr++=7;
                  cvideob=1;                 
				break;
                  } //End case
                  
 // Foreground Colors.  \#n
             case '#':{
                  
                switch(ptr[2])
                {  
                  case '0':{ // Black
                  *outptr++=16;
                  *outptr++=0;
                  ptr++;
                  cvideof=1;                 
			      break;
                  } //End case           
                  case '1':{ // Blue
                  *outptr++=16;
                  *outptr++=1;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '2':{ // Red
                  *outptr++=16;
                  *outptr++=2;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '3':{ // Maganta
                  *outptr++=16;
                  *outptr++=3;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '4':{ // Green
                  *outptr++=16;
                  *outptr++=4;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '5':{ // Cyan
                  *outptr++=16;
                  *outptr++=5;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '6':{ // Yellow
                  *outptr++=16;
                  *outptr++=6;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                  case '7':{ // White
                  *outptr++=16;
                  *outptr++=7;
                  ptr++;
                  cvideof=1;                 
				  break;
                  } //End case
                } //End Switch                
 			    break;
            }  //End case
 // << ADD BY XavSnap   
                                                               
            case '\'': case '.': case ':': case ' ': /* block graphics char */
             {
			  *outptr++=grok_block(ptr,textlinenum);
			   fprintf(stderr,"grok_block: %d  %d\n",*outptr,in_quotes);
               ptr++;
               gr_block=1;
            break;
             } //End case
             
            default:
            {
              fprintf(stderr,"line %d: warning: unknown escape `%c', inserting literally\n",
                textlinenum,ptr[1]);
               *outptr++=ptr[1];
            } //End case
        } //End switch
             ptr+=2;
        continue; 
      }  //End ELSE
    
     }   //End UDG GRAPHICS CHARACTERS
	  
	  // ...Next...
        
      /* spot any numbers (because we have to add the inline FP
       * representation). We do this largely by relying on strtod(),
       * so that we only have to find the start - i.e. a non-alpha char,
       * an optional `-' or `+', an optional `.', then a digit.
       */
      if(!in_rem && !in_quotes && !isalpha(ptr[-1]) &&
         (isdigit(*ptr) ||
          ((*ptr=='-' || *ptr=='+' || *ptr=='.') && isdigit(ptr[1])) ||
          ((*ptr=='-' || *ptr=='+') && ptr[1]=='.' && isdigit(ptr[2]))))
        {
          if(ptr[-1]!=BIN_TOKEN_NUM)
          {
		  /* we have a number. parse with strtod(). */
          num=strtod(ptr,(char **)&ptr2);
          }
          else
          {
          /* however, if the number was after a BIN token, the inline
           * number must match the binary number, e.g. BIN 1001 would be
           * followed by an inline 9.
           */
          ptr2=ptr;
          num=(double)grok_binary(&ptr2,textlinenum);
          }
        
        /* output text of number */
        memcpy(outptr,ptr,ptr2-ptr);
        outptr+=ptr2-ptr;
        
        *outptr++=0x0e;
         if(!dbl2spec(num,&num_exp,&num_mantissa))
           {
          fprintf(stderr,"line %d: exponent out of range (number too big)\n",
            textlinenum);
          exit(1);
           }
        *outptr++=num_exp;
        *outptr++=(num_mantissa>>24);
        *outptr++=(num_mantissa>>16);
        *outptr++=(num_mantissa>>8);
        *outptr++=(num_mantissa&255);
        ptr=ptr2;
        }
      else
        {
        /* if not number, just output char */
       	  if(!in_quotes){
		   *outptr++=*ptr++;
		   fprintf(stderr,"just output:%d  %d\n",*outptr,in_quotes);
		   }
		   
		}
      } \\ End of Spectrum line.
    
    *outptr++=0x0d;	/* add terminating CR */
    
    /* output line */
    linelen=outptr-outbuf;
    
    if(fileptr+4+linelen>=filebuf+sizeof(filebuf))
      {
      /* the program would be too big to load into a speccy long before
       * you'd get this error, but FWIW...
       */
      fprintf(stderr,"program too big!\n");
      exit(1);
      }
      
    *fileptr++=(linenum>>8);
    *fileptr++=(linenum&255);
    *fileptr++=(linelen&255);
    *fileptr++=(linelen>>8);
    memcpy(fileptr,outbuf,linelen);
    fileptr+=linelen;
    }	/* end of pass-making while() */
  
  passnum++;
  }	/* end of do..while() pass loop */
  
while(use_labels && passnum<=2);

if(in!=stdin) fclose(in);
}

/* we only need to do this if outputting a .tap, but might as well do
 * it to check the label's ok anyway.
 */
if(*startlabel)
  {
  /* this is nearly a can't happen error, but FWIW... */
  if(!use_labels)
    fprintf(stderr,"Auto-start label specified, but not using labels!\n"),
      exit(1);
  for(f=0;f<labelend;f++)
    if(strcmp(startlabel,labels[f])==0) startline=label_lines[f]; break;
     
    if(f==labelend) fprintf(stderr,"Auto-start label is undefined\n"),exit(1);
  }


/* write output file */
if (output_tap==2 && outfile==DEFAULT_OUTPUT) strcpy(outfile,DEFAULT_OUTPUT_TZX);
 
   if(merged_mode==0)
    {
  	// Open a new stream and erase previour file.
      if(strcmp(outfile,"-")!=0 && (out=fopen(outfile,"wb"))==NULL)
       fprintf(stderr,"Couldn't open output file.\n"),exit(1);
    }else{
   	// Open a new stream and overwrite it. 
      if(strcmp(outfile,"-")!=0 && (out=fopen(outfile,"a+b"))==NULL)
       fprintf(stderr,"Couldn't open output file.\n"),exit(1);
    }
  	
   merge_off=0;  
   	
//fprintf(stderr,"Format=%d.\n",output_tap);
  
// Old "TAP" Files Write.
if(output_tap==1)
  {
  	
  unsigned int siz=fileptr-filebuf;
  
  /* make header */
  headerbuf[0]=0;
  for(f=strlen(speccy_filename);f<10;f++)
    speccy_filename[f]=32;
  strncpy(headerbuf+1,speccy_filename,10);
  headerbuf[11]=(siz&255);
  headerbuf[12]=(siz/256);
  headerbuf[13]=(startline&255);
  headerbuf[14]=(startline/256);
  headerbuf[15]=(siz&255);
  headerbuf[16]=(siz/256);
  
  /* Go to the end of tape, if it's a merged file. */
   if(merged_mode==1)
  {
  	merge_off=ftell (out);
  	fseek(out,merge_off,0);  
  }  
	
  /* write header */
  fprintf(out,"%c%c%c",19,0,chk=0);
  for(f=0;f<17;f++) chk^=headerbuf[f];
  fwrite(headerbuf,1,17,out);
  fputc(chk,out);
  
  /* write (most of) tap bit for data block */
  fprintf(out,"%c%c%c",(siz+2)&255,(siz+2)>>8,chk=255);
  for(f=0;f<siz;f++) chk^=filebuf[f];
  }


// "TZX" Files Write.
if(output_tap==2)
  {
   
    unsigned int siz=fileptr-filebuf;
    
 /* Go to the end of tape, if it's a merged file. */
   if(merged_mode==1)
  { 
   	merge_off=ftell (out);
  	fseek(out,merge_off,0);
  }else{
     /* Write TZX tag.*/               
      fprintf(out,"ZXTape!",0,0,chk=0);
      fprintf(out,"%c%c%c%c",26,1,13,48);
      fprintf(out,"%c",((strlen(speccy_filename)+14+strlen(ZmakeBasVER))&255));  
      fprintf(out,"\"%s\" created by %s",speccy_filename,ZmakeBasVER);
  }    
   
   fprintf(out,"%c%c",16,184);
   fprintf(out,"%c%c%c%c",11,19,0,0);
      
  /* make header */
  headerbuf[0]=0;
  for(f=strlen(speccy_filename);f<10;f++)
    speccy_filename[f]=32;
  strncpy(headerbuf+1,speccy_filename,10);
  headerbuf[11]=(siz&255);
  headerbuf[12]=(siz/256);
  headerbuf[13]=(startline&255);
  headerbuf[14]=(startline/256);
  headerbuf[15]=(siz&255);
  headerbuf[16]=(siz/256);
  
  /* write header */
  for(f=0;f<17;f++) chk^=headerbuf[f];
  fwrite(headerbuf,1,17,out);
  fputc(chk,out);
  
  /* write (most of) tap bit for data block */
   fprintf(out,"%c%c%c%c%c%c",16,184,11,(siz+2)&255,(siz+2)>>8,255);
  chk=255;
  for(f=0;f<siz;f++) chk^=filebuf[f];
             
  }

fwrite(filebuf,1,fileptr-filebuf,out);

if(output_tap==1 || output_tap==2 ) fputc(chk,out);

if(out!=stdout) fclose(out); 

  if(merged_mode==0)
  {
  fprintf(stderr,"\"%s\" : \"%s\" Compiled.\n",outfile,speccy_filename);
  } else {
  fprintf(stderr,"\"%s\" : \"%s\" file added.\n",outfile,speccy_filename); 
  }

exit(0);
}

